## keyd 2.5.0

=== Makefile ===
.PHONY: all clean install uninstall debug man compose test-harness
VERSION=2.5.0
COMMIT=$(shell git describe --no-match --always --abbrev=7 --dirty)
VKBD=uinput
PREFIX?=/usr/local

CONFIG_DIR?=/etc/keyd
SOCKET_PATH=/var/run/keyd.socket

CFLAGS:=-DVERSION=\"v$(VERSION)\ \($(COMMIT)\)\" \
	-I/usr/local/include \
	-L/usr/local/lib \
	-Wall \
	-Wextra \
	-Wno-unused \
	-std=c11 \
	-DSOCKET_PATH=\"$(SOCKET_PATH)\" \
	-DCONFIG_DIR=\"$(CONFIG_DIR)\" \
	-DDATA_DIR=\"$(PREFIX)/share/keyd\" \
	-D_FORTIFY_SOURCE=2 \
	-D_DEFAULT_SOURCE \
	-Werror=format-security \
	$(CFLAGS)

platform=$(shell uname -s)

ifeq ($(platform), Linux)
	COMPAT_FILES=
else
	LDFLAGS+=-linotify
	COMPAT_FILES=
endif

all:
	-mkdir bin
	cp scripts/keyd-application-mapper bin/
	sed -e 's#@PREFIX@#$(PREFIX)#' keyd.service.in > keyd.service
	sed -e 's#@PREFIX@#$(PREFIX)#' src/vkbd/usb-gadget.service.in > src/vkbd/usb-gadget.service
	$(CC) $(CFLAGS) -O3 $(COMPAT_FILES) src/*.c src/vkbd/$(VKBD).c -lpthread -o bin/keyd $(LDFLAGS)
debug:
	CFLAGS="-g -fsanitize=address -Wunused" $(MAKE)
compose:
	-mkdir data
	./scripts/generate_xcompose
man:
	for f in docs/*.scdoc; do \
		target=$${f%%.scdoc}.1.gz; \
		target=data/$${target##*/}; \
		scdoc < "$$f" | gzip > "$$target"; \
	done
install:
	@if [ -e /run/systemd/system ]; then \
		mkdir -p $(DESTDIR)$(PREFIX)/lib/systemd/system/; \
		install -Dm644 keyd.service $(DESTDIR)$(PREFIX)/lib/systemd/system/keyd.service; \
	else \
		echo "NOTE: systemd not found, you will need to manually add keyd to your system's init process."; \
	fi

	@if [ "$(VKBD)" = "usb-gadget" ]; then \
		install -Dm644 src/vkbd/usb-gadget.service $(DESTDIR)$(PREFIX)/lib/systemd/system/keyd-usb-gadget.service; \
		install -Dm755 src/vkbd/usb-gadget.sh $(DESTDIR)$(PREFIX)/bin/keyd-usb-gadget.sh; \
	fi

	mkdir -p $(DESTDIR)$(CONFIG_DIR)
	mkdir -p $(DESTDIR)$(PREFIX)/bin/
	mkdir -p $(DESTDIR)$(PREFIX)/share/keyd/
	mkdir -p $(DESTDIR)$(PREFIX)/share/keyd/layouts/
	mkdir -p $(DESTDIR)$(PREFIX)/share/man/man1/
	mkdir -p $(DESTDIR)$(PREFIX)/share/doc/keyd/
	mkdir -p $(DESTDIR)$(PREFIX)/share/doc/keyd/examples/

	-groupadd keyd
	install -m755 bin/* $(DESTDIR)$(PREFIX)/bin/
	install -m644 docs/*.md $(DESTDIR)$(PREFIX)/share/doc/keyd/
	install -m644 examples/* $(DESTDIR)$(PREFIX)/share/doc/keyd/examples/
	install -m644 layouts/* $(DESTDIR)$(PREFIX)/share/keyd/layouts
	cp -r data/gnome-* $(DESTDIR)$(PREFIX)/share/keyd
	install -m644 data/*.1.gz $(DESTDIR)$(PREFIX)/share/man/man1/
	install -m644 data/keyd.compose $(DESTDIR)$(PREFIX)/share/keyd/

uninstall:
	-groupdel keyd
	rm -rf $(DESTDIR)$(PREFIX)/lib/systemd/system/keyd.service \
		$(DESTDIR)$(PREFIX)/bin/keyd \
		$(DESTDIR)$(PREFIX)/bin/keyd-application-mapper \
		$(DESTDIR)$(PREFIX)/share/doc/keyd/ \
		$(DESTDIR)$(PREFIX)/share/man/man1/keyd*.gz \
		$(DESTDIR)$(PREFIX)/share/keyd/ \
		$(DESTDIR)$(PREFIX)/lib/systemd/system/keyd-usb-gadget.service \
		$(DESTDIR)$(PREFIX)/bin/keyd-usb-gadget.sh \
		$(DESTDIR)$(PREFIX)/lib/systemd/system/keyd.service
clean:
	-rm -rf bin keyd.service src/vkbd/usb-gadget.service
test:
	@cd t; \
	for f in *.sh; do \
		./$$f; \
	done
test-io:
	-mkdir bin
	$(CC) \
	-DDATA_DIR= \
	-o bin/test-io \
		t/test-io.c \
		src/keyboard.c \
		src/string.c \
		src/macro.c \
		src/config.c \
		src/log.c \
		src/ini.c \
		src/keys.c  \
		src/unicode.c && \
	./bin/test-io t/test.conf t/*.t

=== debian/changelog ===
keyd (2.5.0-5) unstable; urgency=medium

  * Team upload
  * Move to unstable

 -- Bastian Germann <bage@debian.org>  Tue, 12 Aug 2025 18:54:23 +0200

keyd (2.5.0-5~exp1) experimental; urgency=medium

  * debian/gbp.conf: Use --ignore-branch by default
  * debian/copyright: Bump upstream copyright year to 2024
  * Cherry-pick upstream fix to silence Python syntax warning
  * Define autopkgtest for upstream's integration test suite

 -- Richard Hansen <rhansen@rhansen.org>  Thu, 29 May 2025 18:53:58 -0400

keyd (2.5.0-4) unstable; urgency=medium

  * Change architecture to linux-all (keyd is Linux-specific) (Closes: #1106189)
  * Fix build on architectures without time member in struct input_event
    (Closes: #1106190)

 -- Richard Hansen <rhansen@rhansen.org>  Tue, 20 May 2025 17:20:58 -0400

keyd (2.5.0-3) unstable; urgency=medium

  * Update Debian VCS URL to the project's new location
  * Fix keyd-application-mapper running the wrong keyd executable.
    Thanks to Martin Marshall for the fix (Closes: #1106031)

 -- Richard Hansen <rhansen@rhansen.org>  Tue, 20 May 2025 03:12:46 -0400

keyd (2.5.0-2) unstable; urgency=medium

  * Restore unintentionally removed debian/.gitignore
  * Rename /usr/bin/keyd to keyd.rvaiya to avoid conflict with onak
    (Closes: #1098982)
  * Bump copyright year for debian/*
  * debian/watch: Simplify regex
  * debian/watch: Mangle -alpha, -beta, -rc to ~alpha, ~beta, ~rc
  * Bump Standards-Version to 4.7.2

 -- Richard Hansen <rhansen@rhansen.org>  Tue, 18 Mar 2025 02:29:23 -0400

keyd (2.5.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No change source-only upload for testing migration.

 -- Boyuan Yang <byang@debian.org>  Tue, 11 Feb 2025 13:06:47 -0500

keyd (2.5.0-1) unstable; urgency=medium

  * Initial version. (Closes: #1060023)

 -- Richard Hansen <rhansen@rhansen.org>  Tue, 10 Sep 2024 17:53:13 -0400

=== debian/control ===
Source: keyd
Section: utils
Priority: optional
Maintainer: Richard Hansen <rhansen@rhansen.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 python3,
 scdoc,
Standards-Version: 4.7.2
Homepage: https://github.com/rvaiya/keyd
Vcs-Browser: https://salsa.debian.org/debian/keyd
Vcs-Git: https://salsa.debian.org/debian/keyd.git

Package: keyd
Architecture: linux-any
Multi-Arch: foreign
Depends:
# passwd is only required for groupadd/groupdel in keyd.postinst/keyd.postrm
 passwd,
 ${shlibs:Depends},
 ${misc:Depends},
Description: keyboard key remapping daemon
 keyd is a system-wide key remapping daemon which supports features like
 layering, oneshot modifiers, and macros. In its most basic form it can be used
 to define a custom key layout that persists across display server boundaries
 (e.g wayland/X/tty).

Package: keyd-application-mapper
Architecture: all
Multi-Arch: foreign
Depends:
 keyd,
 ${python3:Depends},
 ${misc:Depends},
Recommends:
 python3-xlib,
Description: keyboard key remapping daemon - application-specific remapper
 keyd is a system-wide key remapping daemon which supports features like
 layering, oneshot modifiers, and macros. In its most basic form it can be used
 to define a custom key layout that persists across display server boundaries
 (e.g wayland/X/tty).
 .
 This package provides a keyd companion daemon that adds support for
 application-specific key bindings by watching for window focus changes. At the
 moment, X, Sway, and GNOME are supported.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	PREFIX=/usr dh $@ --with python3

# `make test` requires root because the tests are run as integration tests that communicate with the
# kernel. `make test-io` runs the same test suite but mocks interactions so it doesn't need root.
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) test-io
endif

=== debian/tests/control ===
Test-Command: keyd.rvaiya --version
Depends: keyd
Restrictions: superficial

Test-Command: man keyd.rvaiya >/dev/null
Depends: keyd, man
Restrictions: superficial

Test-Command: keyd-application-mapper --help
Depends: keyd-application-mapper
Restrictions: superficial

Test-Command: man keyd-application-mapper >/dev/null
Depends: keyd-application-mapper, man
Restrictions: superficial

Tests: integration
Depends: keyd, python3:any
Restrictions: isolation-machine, needs-root

=== debian/watch ===
version=4
opts=\
filenamemangle=s%.*?/v(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%,\
uversionmangle=s/-(alpha|beta|rc)/~$1/ \
    https://github.com/rvaiya/keyd/tags \
    .*?/v@ANY_VERSION@@ARCHIVE_EXT@
